//
//  BarcodePickerController2.h
//  ScanditBarcodeScanner
//
//  Created by Moritz Hartmeier on 20/08/15.
//  Copyright (c) 2015 Scandit AG. All rights reserved.
//

#import <UIKit/UIKit.h>

#import <ScanditBarcodeScanner/ScanditBarcodeScanner.h>
#import "BarcodeResult.h"


@class BarcodePickerController2;

@protocol BarcodePickerControllerDelegate <NSObject>
@optional
- (void) barcodePickerController:(BarcodePickerController2 *)picker
                   returnResults:(NSSet *)results;
@end


@interface BarcodePickerController2 : SBSBarcodePicker

@property (nonatomic, assign) BOOL scanUPCE;
@property (nonatomic, assign) BOOL scanEAN8;
@property (nonatomic, assign) BOOL scanEAN13;
@property (nonatomic, assign) BOOL scanQRCODE;
@property (nonatomic, assign) BOOL scanCODE128;
@property (nonatomic, assign) BOOL scanCODE39;
@property (nonatomic, assign) BOOL scanDATAMATRIX;
@property (nonatomic, assign) BOOL scanITF;
@property (nonatomic, assign) BOOL scanEAN5;
@property (nonatomic, assign) BOOL scanEAN2;
@property (nonatomic, assign) BOOL scanCODABAR;
@property (nonatomic, assign) BOOL scanCODE93;
@property (nonatomic, assign) BOOL scanPDF417;
@property (nonatomic, assign) BOOL scanGS1Databar;
@property (nonatomic, assign) BOOL scanGS1DatabarExpanded;

#if __has_feature(objc_arc)
@property (nonatomic, weak) id <BarcodePickerControllerDelegate> delegate;
#else
@property (nonatomic, assign) id <BarcodePickerControllerDelegate> delegate;
#endif
@property (nonatomic, assign) BOOL useFrontCamera;

// Torch
- (BOOL)hasTorch;
- (BOOL)isTorchOn;
- (void)turnTorch:(BOOL)value;

// Focus/Exposure
- (bool)canFocus;
@property (readonly, assign)  BOOL isFocusing;
@property (nonatomic, assign) BOOL exposureLock;

- (void)prepareToScan;
- (void)clearResultsSet;
- (void)doneScanning;
- (void)startCollectingLocationData;
- (void)requestCameraSnapshot:(bool) stillPictureSized;
- (void)statusUpdated:(NSDictionary*) status;
- (void)reportUnwantedBarcode:(BarcodeResult *) barcode;

@end
